<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html
  xmlns="http://www.w3.org/1999/xhtml"
  xmlns:xi="http://www.w3.org/2001/XInclude"
  xml:lang="en">
<head>
  <title>HTTP Protocol Removal Full Disclosure - Security - HTML Purifier</title>
  <xi:include href="common-meta.xml" xpointer="xpointer(/*/node())" />
  <meta name="description" content="Full disclosure security page detailing the HTTP protocol removal attack." />
  <meta name="keywords" content="HTMLPurifier, HTML Purifier, HTML, filter, filtering, standards, compliant, 3.1.0, attack, full disclosure, http, xss, security" />
</head>
<body>

<xi:include href="common-header.xml" xpointer="xpointer(/*/node())" />

<div id="main">
<h1 id="title">HTTP Protocol Removal Full Disclosure</h1>

<div id="content">

<p>
  An error in the <code>HTMLPurifier_URI-&gt;validate()</code> allowed for 
  an attacker craft a specially formed <abbr>URI</abbr> that, once processed by HTML
  Purifier, was an active JavaScript <abbr>URI</abbr>. If a user clicked on the malicious
  link, or used a browser that automatically evaluates JavaScript <abbr>URI</abbr>s in
  image tags, an attacker could execute arbitrary JavaScript in the context
  of the website the <abbr>HTML</abbr> was served on.
</p>

<p>
  This vulnerability was reported via full disclosure by
  <a href="http://sla.ckers.org/forum/read.php?14,21598#msg-21604">Gareth Heyes</a>,
  and brought to the attention of the vendor by CrYpTiC_MauleR.
  No active exploits are currently known.
</p>

<h2 id="Fix">Fix</h2>

<p>
  This vulnerability was fixed in HTML Purifier 3.1.0 and 2.1.4. No hot-patch
  is currently available.
</p>

<h2 id="Details">Details</h2>

<p>
  In accordance to <a href="http://tools.ietf.org/html/rfc3986#page-37">RFC 3986</a>,
  a relative <abbr>URI</abbr> with the same scheme name as the
  base <abbr>URI</abbr> is discouraged, but allowed for backwards-compatibility.
  As HTML Purifier's goal is to produce standards-compliance in all aspects
  of its output, HTML Purifier converts such <abbr>URI</abbr>s to their
  correct form by removing the scheme. Thus, <code>http:dir/dir2</code>
  becomes <code>dir/dir2</code>.
</p>

<p>
  Doing this bypasses HTML Purifier's safeguards against JavaScript
  <abbr>URI</abbr>s. During the parsing of normal URIs, a URI is parsed
  and its scheme extracted from the original. Thus, a normal
  <code>javascript:xss()</code> is identified to have a <code>javascript</code>
  scheme and is removed. Any of the common bypasses to this, such as
  <code>java<strong>\n</strong>script</code> are avoided because HTML Purifier
  does not recognize the scheme from its list of allowed schemes. However, once
  parsing and this initial scheme check is performed, parsing is not 
  performed again.
</p>

<p>
  Removal of the scheme causes a URI like <code>http:javascript:xss()</code>
  to become <code>javascript:xss()</code>, and now <code>javascript</code> is
  the new scheme, although in the original, <code>javascript:xss()</code> was
  the <em>path</em>.
</p>

<table>
  <thead>
    <tr>
      <th>Key</th>
      <th>Original</th>
      <th>New</th>
      <th>Intended</th>
    </tr>
  </thead>
  <tbody>
    <tr>
      <th>Scheme</th>
      <td>http</td>
      <td>javascript</td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <th>Path</th>
      <td>javascript:xss()</td>
      <td>xss()</td>
      <td>javascript:xss()</td>
    </tr>
  </tbody>
</table>

<p>
  The appropriate fix can be determined by figuring out how to convert the
  last column into a <abbr>URI</abbr> that will be parsed into the same form.
  Obviously, simple concatenation doesn't work; the key is percent encoding
  the path. Instead of <code>javascript:xss()</code>, <code>javascript%3Axss()</code>
  should be used.
</p>

<p>
  HTML Purifier's fix also percent-encodes any other reserved character in
  each segment of a URI. This was actually a previously identified section
  of relaxed standards compliance, and strictly enforcing the rules eliminated
  the vulnerability.
</p>

<h2 id="History">History</h2>

<p>
  The vulnerability was reported on March 25, 2008, although not directly to
  the vendor. A patch was committed to the public repository on May 13, 2008,
  ostensibly as a <q>revamp [of] URI handling of percent encoding and validation.</q>
  HTML Purifier 3.1.0 was released on May 18, 2008. This was the first security
  vulnerability in HTML Purifier's core, and the second in all of HTML Purifier's
  history.
</p>

<p>
  We would have strongly preferred if Gareth Heyes had contacted us through
  private channels before publically disclosing the vulnerability. We actually
  did not realize that the post was illustrating vulnerabilities with
  HTML Purifier until CrYpTiC_MauleR asked why the exploit worked on
  May 13, 2007 (an <code>http:javascript:</code> doesn't actually work by itself; HTML Purifier
  must munge off the http scheme to activate the attack.) This accounts in
  part for the large discrepancy between the first disclosure,
  and the committing of a fix. Still, we greatly appreciate Gareth Heyes' report
  and sincerely hope that he will continue to help weed out bugs in HTML Purifier.
  We apologize for not crediting him immediately in the changelog.
</p>

<p>
  Since full disclosure is generally a good idea, just not before the vendor
  has gotten a chance to release a fix (please don't be afraid to use it to
  light a fire under our butts and get a security bug fixed), we've released
  this document along with the next point release of HTML Purifier, hopefully
  having given projects and end users enough time to upgrade their installations.
  We hope to do this for all future vulnerabilities in HTML Purifier. Especially
  for the two which were fixed in the most recent point release.
</p>

</div>
</div>

</body>
</html>
